Index: /NEMO/branches/2019/dev_r11842_SI3-10_EAP/src/NST/agrif_oce_interp.F90
===================================================================
--- /NEMO/branches/2019/dev_r11842_SI3-10_EAP/src/NST/agrif_oce_interp.F90	(revision 13661)
+++ /NEMO/branches/2019/dev_r11842_SI3-10_EAP/src/NST/agrif_oce_interp.F90	(revision 13662)
@@ -96,11 +96,11 @@
       i1 =  1   ;   i2 = nlci
       j1 =  1   ;   j2 = nlcj
-      IF( nbondj == -1 .OR. nbondj == 2 )   j1 = 2 + nbghostcells
-      IF( nbondj == +1 .OR. nbondj == 2 )   j2 = nlcj - nbghostcells - 1
-      IF( nbondi == -1 .OR. nbondi == 2 )   i1 = 2 + nbghostcells 
-      IF( nbondi == +1 .OR. nbondi == 2 )   i2 = nlci - nbghostcells - 1
+      IF( l_Southedge )   j1 = 2 + nbghostcells
+      IF( l_Northedge )   j2 = nlcj - nbghostcells - 1
+      IF( l_Westedge )    i1 = 2 + nbghostcells 
+      IF( l_Eastedge )    i2 = nlci - nbghostcells - 1
 
       ! --- West --- !
-      IF( nbondi == -1 .OR. nbondi == 2 ) THEN
+      IF( l_Westedge ) THEN
          ibdy1 = 2
          ibdy2 = 1+nbghostcells 
@@ -173,5 +173,5 @@
 
       ! --- East --- !
-      IF( nbondi ==  1 .OR. nbondi == 2 ) THEN
+      IF( l_Eastedge ) THEN
          ibdy1 = nlci-1-nbghostcells
          ibdy2 = nlci-2 
@@ -246,5 +246,5 @@
 
       ! --- South --- !
-      IF( nbondj == -1 .OR. nbondj == 2 ) THEN
+      IF ( l_Southedge ) THEN
          jbdy1 = 2
          jbdy2 = 1+nbghostcells 
@@ -318,5 +318,5 @@
 
       ! --- North --- !
-      IF( nbondj ==  1 .OR. nbondj == 2 ) THEN
+      IF( l_Northedge ) THEN
          jbdy1 = nlcj-1-nbghostcells
          jbdy2 = nlcj-2 
@@ -405,5 +405,5 @@
       IF( Agrif_Root() )   RETURN
       !
-      IF((nbondi == -1).OR.(nbondi == 2)) THEN
+      IF( l_Westedge ) THEN
          DO jj=1,jpj
             va_e(2:nbghostcells+1,jj) = vbdy_w(1:nbghostcells,jj) * hvr_e(2:nbghostcells+1,jj)
@@ -416,5 +416,5 @@
       ENDIF
       !
-      IF((nbondi == 1).OR.(nbondi == 2)) THEN
+      IF( l_Eastedge ) THEN
          DO jj=1,jpj
             va_e(nlci-nbghostcells:nlci-1,jj)   = vbdy_e(1:nbghostcells,jj) * hvr_e(nlci-nbghostcells:nlci-1,jj)
@@ -427,5 +427,5 @@
       ENDIF
       !
-      IF((nbondj == -1).OR.(nbondj == 2)) THEN
+      IF ( l_Southedge ) THEN
          DO ji=1,jpi
             ua_e(ji,2:nbghostcells+1) = ubdy_s(ji,1:nbghostcells) * hur_e(ji,2:nbghostcells+1)
@@ -438,5 +438,5 @@
       ENDIF
       !
-      IF((nbondj == 1).OR.(nbondj == 2)) THEN
+      IF ( l_Northedge ) THEN
          DO ji=1,jpi
             ua_e(ji,nlcj-nbghostcells:nlcj-1)   = ubdy_n(ji,1:nbghostcells) * hur_e(ji,nlcj-nbghostcells:nlcj-1)
@@ -516,5 +516,5 @@
       !
       ! --- West --- !
-      IF((nbondi == -1).OR.(nbondi == 2)) THEN
+      IF( l_Westedge ) THEN
          indx = 1+nbghostcells
          DO jj = 1, jpj
@@ -526,5 +526,5 @@
       !
       ! --- East --- !
-      IF((nbondi == 1).OR.(nbondi == 2)) THEN
+      IF( l_Eastedge ) THEN
          indx = nlci-nbghostcells
          DO jj = 1, jpj
@@ -536,5 +536,5 @@
       !
       ! --- South --- !
-      IF((nbondj == -1).OR.(nbondj == 2)) THEN
+      IF ( l_Southedge ) THEN
          indy = 1+nbghostcells
          DO jj = 2, indy
@@ -546,5 +546,5 @@
       !
       ! --- North --- !
-      IF((nbondj == 1).OR.(nbondj == 2)) THEN
+      IF ( l_Northedge ) THEN
          indy = nlcj-nbghostcells
          DO jj = indy, nlcj-1
@@ -571,5 +571,5 @@
       !
       ! --- West --- !
-      IF((nbondi == -1).OR.(nbondi == 2)) THEN
+      IF( l_Westedge ) THEN
          indx = 1+nbghostcells
          DO jj = 1, jpj
@@ -581,5 +581,5 @@
       !
       ! --- East --- !
-      IF((nbondi == 1).OR.(nbondi == 2)) THEN
+      IF( l_Eastedge ) THEN
          indx = nlci-nbghostcells
          DO jj = 1, jpj
@@ -591,5 +591,5 @@
       !
       ! --- South --- !
-      IF((nbondj == -1).OR.(nbondj == 2)) THEN
+      IF( l_Southedge ) THEN
          indy = 1+nbghostcells
          DO jj = 2, indy
@@ -601,5 +601,5 @@
       !
       ! --- North --- !
-      IF((nbondj == 1).OR.(nbondj == 2)) THEN
+      IF( l_Northedge ) THEN
          indy = nlcj-nbghostcells
          DO jj = indy, nlcj-1
@@ -722,8 +722,8 @@
             ! 
             ! Remove CORNERS
-            IF((nbondj == -1).OR.(nbondj == 2)) jmin = 2 + nbghostcells
-            IF((nbondj == +1).OR.(nbondj == 2)) jmax = nlcj - nbghostcells - 1
-            IF((nbondi == -1).OR.(nbondi == 2)) imin = 2 + nbghostcells
-            IF((nbondi == +1).OR.(nbondi == 2)) imax = nlci - nbghostcells - 1      
+            IF( l_Southedge ) jmin = 2 + nbghostcells
+            IF( l_Northedge ) jmax = nlcj - nbghostcells - 1
+            IF( l_Westedge )  imin = 2 + nbghostcells
+            IF( l_Eastedge )  imax = nlci - nbghostcells - 1      
             !
             IF( eastern_side ) THEN
Index: /NEMO/branches/2019/dev_r11842_SI3-10_EAP/src/NST/agrif_oce_sponge.F90
===================================================================
--- /NEMO/branches/2019/dev_r11842_SI3-10_EAP/src/NST/agrif_oce_sponge.F90	(revision 13661)
+++ /NEMO/branches/2019/dev_r11842_SI3-10_EAP/src/NST/agrif_oce_sponge.F90	(revision 13662)
@@ -109,5 +109,5 @@
 
          ! --- West --- !
-         IF( (nbondi == -1) .OR. (nbondi == 2) ) THEN
+         IF( l_Westedge ) THEN
             ind1 = 1+nbghostcells
             ind2 = 1+nbghostcells + ispongearea 
@@ -120,5 +120,5 @@
 
          ! --- East --- !
-         IF( (nbondi == 1) .OR. (nbondi == 2) ) THEN
+         IF( l_Eastedge ) THEN
             ind1 = nlci - nbghostcells - ispongearea
             ind2 = nlci - nbghostcells
@@ -131,5 +131,5 @@
 
          ! --- South --- !
-         IF( (nbondj == -1) .OR. (nbondj == 2) ) THEN
+         IF( l_Southedge ) THEN
             ind1 = 1+nbghostcells
             ind2 = 1+nbghostcells + ispongearea
@@ -142,5 +142,5 @@
 
          ! --- North --- !
-         IF( (nbondj == 1) .OR. (nbondj == 2) ) THEN
+         IF( l_Northedge ) THEN
             ind1 = nlcj - nbghostcells - ispongearea
             ind2 = nlcj - nbghostcells
@@ -454,5 +454,5 @@
 
          jmax = j2-1
-         IF ((nbondj == 1).OR.(nbondj == 2)) jmax = MIN(jmax,nlcj-nbghostcells-2)   ! North
+         IF ( l_Northedge ) jmax = MIN(jmax,nlcj-nbghostcells-2)   ! North
 
          DO jj = j1+1, jmax
@@ -580,5 +580,5 @@
 
          imax = i2 - 1
-         IF ((nbondi == 1).OR.(nbondi == 2))   imax = MIN(imax,nlci-nbghostcells-2)   ! East
+         IF ( l_Eastedge )   imax = MIN(imax,nlci-nbghostcells-2)   ! East
 
          DO jj = j1+1, j2
Index: /NEMO/branches/2019/dev_r11842_SI3-10_EAP/src/NST/agrif_top_interp.F90
===================================================================
--- /NEMO/branches/2019/dev_r11842_SI3-10_EAP/src/NST/agrif_top_interp.F90	(revision 13661)
+++ /NEMO/branches/2019/dev_r11842_SI3-10_EAP/src/NST/agrif_top_interp.F90	(revision 13662)
@@ -136,8 +136,8 @@
             ! 
             ! Remove CORNERS
-            IF((nbondj == -1).OR.(nbondj == 2)) jmin = 2 + nbghostcells
-            IF((nbondj == +1).OR.(nbondj == 2)) jmax = nlcj - nbghostcells - 1
-            IF((nbondi == -1).OR.(nbondi == 2)) imin = 2 + nbghostcells
-            IF((nbondi == +1).OR.(nbondi == 2)) imax = nlci - nbghostcells - 1      
+            IF( l_Southedge ) jmin = 2 + nbghostcells
+            IF( l_Northedge ) jmax = nlcj - nbghostcells - 1
+            IF( l_Westedge )  imin = 2 + nbghostcells
+            IF( l_Eastedge )  imax = nlci - nbghostcells - 1      
             !
             IF( eastern_side ) THEN
Index: /NEMO/branches/2019/dev_r11842_SI3-10_EAP/src/NST/agrif_user.F90
===================================================================
--- /NEMO/branches/2019/dev_r11842_SI3-10_EAP/src/NST/agrif_user.F90	(revision 13661)
+++ /NEMO/branches/2019/dev_r11842_SI3-10_EAP/src/NST/agrif_user.F90	(revision 13662)
@@ -519,5 +519,5 @@
    ind2 = 1 + nbghostcells
    ind3 = 2 + nbghostcells
-   CALL agrif_declare_variable((/2,2,0/),(/ind3,ind3,0/),(/'x','y','N'/),(/1,1,1/),(/nlci,nlcj,jpl*(8+nlay_s+nlay_i)/),tra_ice_id)
+   CALL agrif_declare_variable((/2,2,0/),(/ind3,ind3,0/),(/'x','y','N'/),(/1,1,1/),(/nlci,nlcj,jpl*(9+nlay_s+nlay_i)/),tra_ice_id)
    CALL agrif_declare_variable((/1,2/)  ,(/ind2,ind3/)  ,(/'x','y'/)    ,(/1,1/)  ,(/nlci,nlcj/)                      ,u_ice_id  )
    CALL agrif_declare_variable((/2,1/)  ,(/ind3,ind2/)  ,(/'x','y'/)    ,(/1,1/)  ,(/nlci,nlcj/)                      ,v_ice_id  )
@@ -736,7 +736,7 @@
    !
    ! Check sponge length:
-   iminspon = MIN(FLOOR(REAL(jpiglo-4)/REAL(2*Agrif_irhox())), FLOOR(REAL(jpjglo-4)/REAL(2*Agrif_irhox())) )
-   IF (lk_mpp) iminspon = MIN(iminspon,FLOOR(REAL(jpi-2)/REAL(Agrif_irhox())), FLOOR(REAL(jpj-2)/REAL(Agrif_irhox())) )
-   IF (nn_sponge_len > iminspon)  CALL ctl_stop('agrif sponge length is too large')
+   IF(     MIN(jpi   ,jpj   ) <=     1 + nbghostcells + (nn_sponge_len * Agrif_irhox() + 1)     &
+      .OR. MIN(jpiglo,jpjglo) <= 2* (1 + nbghostcells + (nn_sponge_len * Agrif_irhox() + 1) ) ) &
+      &     CALL ctl_stop('STOP','agrif sponge length is too large')
    !
    IF( agrif_oce_alloc()  > 0 )   CALL ctl_warn('agrif agrif_oce_alloc: allocation of arrays failed')
Index: /NEMO/branches/2019/dev_r11842_SI3-10_EAP/src/OCE/BDY/bdy_oce.F90
===================================================================
--- /NEMO/branches/2019/dev_r11842_SI3-10_EAP/src/OCE/BDY/bdy_oce.F90	(revision 13661)
+++ /NEMO/branches/2019/dev_r11842_SI3-10_EAP/src/OCE/BDY/bdy_oce.F90	(revision 13662)
@@ -63,4 +63,5 @@
       REAL(wp), POINTER, DIMENSION(:,:) ::  aip    !: now ice  pond concentration
       REAL(wp), POINTER, DIMENSION(:,:) ::  hip    !: now ice  pond depth
+      REAL(wp), POINTER, DIMENSION(:,:) ::  hil    !: now ice  pond lid depth
 #if defined key_top
       CHARACTER(LEN=20)                   :: cn_obc  !: type of boundary condition to apply
@@ -115,4 +116,5 @@
    REAL(wp), DIMENSION(jp_bdy) ::   rice_apnd               !: pond conc.  of incoming sea ice
    REAL(wp), DIMENSION(jp_bdy) ::   rice_hpnd               !: pond thick. of incoming sea ice
+   REAL(wp), DIMENSION(jp_bdy) ::   rice_hlid               !: pond lid thick. of incoming sea ice
    !
    !!----------------------------------------------------------------------
